#!/usr/bin/env python
# -*- coding: utf-8 -*-

#   JAMedia.py por:
#   Flavio Danesse <fdanesse@gmail.com>
#   Ceibal Jam - Uruguay
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gtk
import pygtk
pygtk.require("2.0")

import os, time, string, sys, gobject

from Archivos_y_Directorios import Archivos_y_Directorios
from Mplayer_Reproductor import Mplayer_Reproductor
from Lista_de_Reproduccion import Lista_de_Reproduccion

ICONOS = os.getcwd() + "/Iconos/"
COLOR1 = gtk.gdk.Color(0,0,0,1) # Negro
MAX_WIDTH = 320
MAX_HEIGHT = 240
DIRECTORIO_MIS_ARCHIVOS = os.getcwd()+"/MisArchivos/"
DIRECTORIO_DATOS = os.getcwd()+"/Datos/"

class JAMedia(gtk.Window):
	def __init__(self):
		gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)

		self.mplayer_server = None

		# Las Base de datos
		self.origenes_de_datos = Archivos_y_Directorios(DIRECTORIO_DATOS, DIRECTORIO_MIS_ARCHIVOS)
		self.origenes_de_datos.Generar_Origenes_de_Datos()

		# Lista de Radios
		self.Lista_de_Radios = self.origenes_de_datos.Cargar_Tabla("Radios")
		self.Lista_de_Television = self.origenes_de_datos.Cargar_Tabla("Television")
		self.Lista_de_Archivos = None
		self.Lista_de_MisRadios = self.origenes_de_datos.Cargar_Tabla("MisRadios")
		self.Lista_de_MisTelevision = self.origenes_de_datos.Cargar_Tabla("MisTelevision")

		# VENTANA
		self.set_title("JAMedia-4-Ubuntu")
		self.set_resizable(True)
		self.set_icon_from_file(ICONOS + "Logo JAMedia Ubuntu.png")
		self.resize(MAX_WIDTH, MAX_HEIGHT)
        	self.connect("delete_event", self.delete_event)
        	self.connect("destroy", self.destroy)
        	self.set_border_width(3)

		# CONTENEDOR BASE 2
		self.panel_base2 = gtk.HPaned() # http://library.gnome.org/devel/pygtk/stable/class-gtkhpaned.html
		# Drawing Area
		self.pantalla = Superficie_de_Reproduccion()
		self.panel_base2.pack1(self.pantalla, resize=False, shrink=True)
		# TreeView - ListStore - Lista de Reproduccion
		self.lista_de_reproduccion = Lista_de_Reproduccion(self)
		
		self.caja_derecha = gtk.VBox()

		# TreeView - ListStore - ComboBox con opciones de Listas de Reproducción
		self.combo = self.get_combo()
		self.get_lista(None) # carga la primera lista
		self.caja_derecha.pack_start (self.combo, False, False, 0)

		scrolled_window = gtk.ScrolledWindow()
       		scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		scrolled_window.add_with_viewport (self.lista_de_reproduccion)
		self.caja_derecha.pack_start (scrolled_window, True, True, 0)
		self.panel_base2.pack2(self.caja_derecha, resize=False, shrink=True)
	
		# CONTENEDOR BASE 1
		self.panel_base1 = gtk.VPaned()
		self.barra_de_estado = Barra_de_Estado(self)

		self.panel_base1.pack1(self.panel_base2, resize=False, shrink=True)
		self.panel_base1.pack2(self.barra_de_estado, resize=False, shrink=True)

		# SHOW
		self.add(self.panel_base1)
		self.show_all() 

		# Reproductor mplayer
		self.mplayer_server = Mplayer_Reproductor(self)
		self.mplayer_server.abrir_presentacion()

# ------------- COMBO CON OPCIONES DE LISTAS DE REPRODUCCION -------------- # 
	def get_combo(self):
		liststore = gtk.ListStore(str)

		combobox = gtk.ComboBox(liststore)

		cell = gtk.CellRendererText()

		combobox.pack_start(cell, True)

		combobox.add_attribute(cell, 'text', 0) # corresponde a cada str en el Listore
		combobox.append_text("JAMedia Radio")
		combobox.append_text("JAMedia TV")
		combobox.append_text("Mis Emisoras de Radio")
		combobox.append_text("Mis Canales de TV")
		combobox.append_text("Mis Archivos")
		combobox.append_text("Otros Archivos")
		combobox.set_active(0) # selecciona la primera lista
		combobox.connect("changed", self.get_lista)
		return combobox

	def get_lista(self, widget):
	# gestiona las acciones sobre selecciones de tipos de listas del combo
		# tomar el indice activo y resolver en consecuencia
		indice = self.combo.get_active()
		# borrar listore primero !!!
		if indice == 0:
		# llenar lista con radios
			tipo = "Radio"
			lista = []
			for x in self.Lista_de_Radios:
				elem = x.split(",")
				texto = elem[0]		# lo que se ve en la lista
				direccion = elem[1]	# la url
				elemento = [texto, direccion, tipo]
				lista.append(elemento)
			self.lista_de_reproduccion.set_listore(lista, "jamediaradio") # llena la lista de reproduccion con las radios
		elif indice == 1:
		# llenar lista con TV
			tipo = "TV"
			lista = []
			for x in self.Lista_de_Television:
				elem = x.split(",")
				texto = elem[0]		# lo que se ve en la lista
				direccion = elem[1]	# la url
				elemento = [texto, direccion, tipo]
				lista.append(elemento)
			self.lista_de_reproduccion.set_listore(lista, "jamediatv") # llena la lista de reproduccion con las TV
		elif indice == 2:
		# llenar lista con Streaming del usuario
			tipo = "Radio"
			lista = []
			for x in self.Lista_de_MisRadios:
				elem = x.split(",")
				texto = elem[0]		# lo que se ve en la lista
				direccion = elem[1]	# la url
				elemento = [texto, direccion, tipo]
				lista.append(elemento)
			self.lista_de_reproduccion.set_listore(lista, "MisRadios")
		elif indice == 3:
		# llenar lista con Streaming del usuario
			tipo = "TV"
			lista = []
			for x in self.Lista_de_MisTelevision:
				elem = x.split(",")
				texto = elem[0]		# lo que se ve en la lista
				direccion = elem[1]	# la url
				elemento = [texto, direccion, tipo]
				lista.append(elemento)
			self.lista_de_reproduccion.set_listore(lista, "MisTelevision")
		elif indice == 4:
		# llenar lista con archivos de videos en el directorio de jamedia
			archivos = sorted(os.listdir(self.origenes_de_datos.directorio_videos))
			tipo = "Audio_Video"
			lista = []
			for texto in archivos:
				direccion = self.origenes_de_datos.directorio_videos + texto
				elemento = [texto, direccion, tipo]
				lista.append(elemento)
			self.lista_de_reproduccion.set_listore(lista, "jamediaarchivos")
		elif indice == 5:
		# Abrir Archivos
			Selector_de_Archivos(self)
		else:
			print "hay acciones sin asignar para opciones del combo"
# ------------- COMBO CON OPCIONES DE LISTAS DE REPRODUCCION -------------- # 

	def ver_video_en_descarga(self, texto):
	# reproduce el video mientras se descarga
		texto = texto +".part"
		tipo = "Audio_Video"
		lista = []
		direccion = self.origenes_de_datos.directorio_videos + texto
		elemento = [texto, direccion, tipo]
		lista.append(elemento)
		self.lista_de_reproduccion.set_listore(lista)
		self.barra_de_estado.Barra_de_Reproduccion.clickenplay_pausa(None)

	def set_lista_archivos(self):
	# crea una lista de archivos y la selecciona para reproduccion
		if self.Lista_de_Archivos:
			tipo = "Audio_Video"
			lista = []
			for x in self.Lista_de_Archivos:
				texto = os.path.basename(x)
				direccion = x
				elemento = [texto, direccion, tipo]
				lista.append(elemento)
			self.lista_de_reproduccion.set_listore(lista, "otrosarchivos")

	def delete_event(self, widget, event, data=None):
		self.Salir(None)
        	return gtk.FALSE

	def destroy(self, widget, data=None):
	# para cerrar ventanas emergentes, selectores de archivos, etc . . .
	# widget siempre es un boton donde se hace click, por eso, se pasa en data la ventana a cerrar
		if data:
			data.destroy()
		else:
			widget.destroy()
		return True

	def Salir(self, widget):
	# Termina la ejecución de JAMedia
		self.mplayer_server.presentacion.quit(None)
		self.mplayer_server.quit(None)
		self.origenes_de_datos.set_permisos() # por compatibilidad con sugar
		sys.exit(0)

	def mensaje_salir(self, widget):
	# Mensaje emergente para confirmar la salida del programa
		'''
		boton_OK = gtk.Button("Si")
		boton_Cancel = gtk.Button("No")

		dialog = gtk.Dialog(title="Mensaje JAMedia", parent=self, flags=gtk.DIALOG_MODAL | gtk.DIALOG_NO_SEPARATOR , buttons=None)
		dialog.set_size_request(250, 80)
		dialog.set_resizable(True)

		label = gtk.Label("¿ Salir de JAMedia ?")
		dialog.vbox.pack_start(label, True, True, 0)

		dialog.action_area.pack_start(boton_OK, True, True, 0)
		dialog.action_area.pack_start(boton_Cancel, True, True, 0)

		boton_OK.connect("clicked", self.Salir)
		boton_Cancel.connect("clicked", self.destroy, dialog) # Cierra el mensaje emergente

		dialog.show_all()'''
		dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
		dialog.set_title("Mensaje JAMedia")
		dialog.set_markup("¿ Salir de JAMedia ?")
		#dialog.set_image(image)
		response = dialog.run()
		dialog.destroy()
		if response == gtk.RESPONSE_YES:
			self.Salir(None)


class Superficie_de_Reproduccion(gtk.EventBox):
# Aca se reproducen los videos
	def __init__(self):
		gtk.EventBox.__init__(self) # http://library.gnome.org/devel/pygtk/stable/class-gtkeventbox.html
		#self.set_flags(gtk.CAN_FOCUS)
		self.modify_bg(gtk.STATE_NORMAL, COLOR1)
		self.resolucion_actual = (MAX_WIDTH, MAX_HEIGHT)
		self.area_de_reproduccion = gtk.DrawingArea() # http://library.gnome.org/devel/pygtk/stable/class-gtkdrawingarea.html
		self.area_de_reproduccion.set_size_request(MAX_WIDTH, MAX_HEIGHT)
		self.area_de_reproduccion.modify_bg(gtk.STATE_NORMAL, COLOR1)

		self.add(self.area_de_reproduccion)

		self.show_all()

class Selector_de_Archivos (gtk.FileChooserDialog):
# Un dialogo para seleccionar archivos de audio y video
	def __init__(self, jamedia):

		self.jamedia = jamedia

		gtk.FileChooserDialog.__init__(self, title="Abrir Archivos de Audio o Video", parent=self.jamedia,
			action=gtk.FILE_CHOOSER_ACTION_OPEN, buttons=None, backend="Coso")

		# Configuraciones
		self.set_current_folder_uri("file:///media")
		self.set_select_multiple(True)

		# extras
		frame = gtk.Frame()
		hbox = gtk.HBox()
		frame.add(hbox)
		boton_abrir_directorio = gtk.Button("Abrir")
		boton_seleccionar_todo = gtk.Button("Seleccionar Todos")
		boton_salir = gtk.Button("Salir")
		hbox.pack_end(boton_salir, True, True, 5)
		hbox.pack_end(boton_seleccionar_todo, True, True, 5)
		hbox.pack_end(boton_abrir_directorio, True, True, 5)

		self.set_extra_widget(frame)

		# filtro para la musica Musica
		filter = gtk.FileFilter()
		filter.set_name("Musica")
		filter.add_mime_type("audio/*")
		self.add_filter(filter)

		filter = gtk.FileFilter()
		filter.set_name("Videos")
		filter.add_mime_type("video/*")
		self.add_filter(filter)

		self.add_shortcut_folder_uri("file:///media/")

		# Callbacks
		boton_salir.connect("clicked", self.salir)
		boton_abrir_directorio.connect("clicked",self.abrir_directorio)
		boton_seleccionar_todo.connect("clicked",self.seleccionar_todos_los_archivos)

		self.show_all()

	def seleccionar_todos_los_archivos(self, widget):
	# Selecciona todos los archivos en el directorio que cumplen con el filtro indicado
		self.select_all()

	def abrir_directorio(self, widget):
	# Carga los archivos seleccionados	
        	self.jamedia.Lista_de_Archivos = self.get_filenames()
		self.jamedia.set_lista_archivos()
		self.salir(None)

	def salir(self, widget):
	# Destruye el filechooser
		self.destroy()

from JAMedia_Downloader import JAMedia_Downloader
class Barra_de_Estado(gtk.HBox):
# Controla la reproduccion e informa al usuario
	def __init__(self, jamedia):
		gtk.HBox.__init__(self)

		self.jamedia = jamedia
		self.descarga = JAMedia_Downloader(self.jamedia)
		self.Actualizador = None

		# Tray
		self.Barra_de_Reproduccion = Barra_de_Reproduccion(self.jamedia)
		self.pack_start(self.Barra_de_Reproduccion, True, True, 3)

		# boton cerrar
		boton_cerrar = gtk.Button()
		tooltips = gtk.Tooltips()
		tooltips.set_tip(boton_cerrar, "Salir de JAMedia", tip_private=None)
		# icono en boton cerrar
		archivodeimagen = ICONOS + "salir.png"
	        cajadelboton = gtk.HBox()
	        imagen = gtk.Image()
	        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(archivodeimagen, 10, 10)
	        imagen.set_from_pixbuf(pixbuf)
	        cajadelboton.pack_start(imagen, False, False, 0)
	        boton_cerrar.add(cajadelboton)
		# connect salir
		boton_cerrar.connect("clicked", self.jamedia.mensaje_salir)

		# boton lista de reproduccion
		boton_Lista_reproduccion = gtk.Button()
		tooltips = gtk.Tooltips()
		tooltips.set_tip(boton_Lista_reproduccion, "Ver/Ocultar Lista de Reproducción", tip_private=None)
		# icono en boton lista de reproduccion
		archivodeimagen = ICONOS + "lista.png"
	        cajadelboton = gtk.HBox()
	        imagen = gtk.Image()
	        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(archivodeimagen, 10, 10)
	        imagen.set_from_pixbuf(pixbuf)
	        cajadelboton.pack_start(imagen, False, False, 0)
	        boton_Lista_reproduccion.add(cajadelboton)
		# connect boton lista de reproduccion
		boton_Lista_reproduccion.connect("clicked", self.ocultar_lista)

		# boton descargas
		boton_descargas = gtk.Button()
		tooltips = gtk.Tooltips()
		tooltips.set_tip(boton_descargas, "Descargas", tip_private=None)
		# icono en boton lista de reproduccion
		archivodeimagen = ICONOS + "descargas.png"
	        cajadelboton = gtk.HBox()
	        imagen = gtk.Image()
	        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(archivodeimagen, 10, 10)
	        imagen.set_from_pixbuf(pixbuf)
	        cajadelboton.pack_start(imagen, False, False, 0)
	        boton_descargas.add(cajadelboton)
		# connect
		boton_descargas.connect("clicked", self.opciones_descarga)

		# boton resolucion
		boton_resolucion = gtk.Button()
		tooltips = gtk.Tooltips()
		tooltips.set_tip(boton_resolucion, "Resolución de Video", tip_private=None)
		# icono en boton resolucion
		archivodeimagen = ICONOS + "monitor.png"
	        cajadelboton = gtk.HBox()
	        imagen = gtk.Image()
	        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(archivodeimagen, 10, 10)
	        imagen.set_from_pixbuf(pixbuf)
	        cajadelboton.pack_start(imagen, False, False, 0)
	        boton_resolucion.add(cajadelboton)
		# connect
		boton_resolucion.connect("button_press_event", self.set_video)

		self.pack_end(boton_cerrar, False, False, 0)
		self.pack_end(boton_Lista_reproduccion, False, False, 0)
		self.pack_end(boton_descargas, False, False, 0)
		self.pack_end(boton_resolucion, False, False, 0)
		self.show_all()

	def opciones_descarga(self, widget):
		self.descarga.hacer_visible()

# -------------- Menu Resoluciones --------------------------
	def set_video(self, widget, event):
		boton = event.button
		pos = (event.x, event.y)
		tiempo = event.time
		self.menu(widget, boton, pos, tiempo)
		return
	def menu(self, widget, boton, pos, tiempo):
	# Crea el menu desplegable
		menu = gtk.Menu()
		resoluciones = [(320,240), (640,480), (800,600), (1024,768)]
		for res in resoluciones:
			item = gtk.MenuItem(str(res))
			menu.append(item)
			item.connect_object("activate", self.set_video_resolucion, res)
		menu.show_all()
		menu.popup(None, None, self.posicionar_menu, boton, tiempo, None)
	def posicionar_menu(self, widget, pos):
		pass
	def set_video_resolucion(self, datos):
	# establece la resolucion del video
		self.jamedia.resize(int(datos[0]), int(datos[1]))
		self.jamedia.pantalla.set_size_request(int(datos[0]), int(datos[1]))
		self.jamedia.pantalla.resolucion_actual = (int(datos[0]), int(datos[1]))
		self.jamedia.set_resizable(True)
# -------------- Menu Resoluciones --------------------------

	def ocultar_lista(self, widget):
	# oculta o muestra la lista de reproduccion
		if self.jamedia.lista_de_reproduccion.visible:
			self.jamedia.panel_base2.remove(self.jamedia.panel_base2.get_child2())
			self.jamedia.lista_de_reproduccion.visible = False
		else:
			self.jamedia.panel_base2.pack2(self.jamedia.caja_derecha, resize=False, shrink=True)
			self.jamedia.lista_de_reproduccion.visible = True
		# mantener resolucion en el video
		datos = self.jamedia.pantalla.resolucion_actual
		self.set_video_resolucion(datos)

	def destroy(self, widget, data=None):
	# para cerrar ventanas emergentes, selectores de archivos, etc . . .
	# widget siempre es un boton donde se hace click, por eso, se pasa en data la ventana a cerrar
		if data:
			data.destroy()
		else:
			widget.destroy()
		return True


# seek <value> [type]
# seek <value> 1 # 1 es el %
class Barra_de_Reproduccion(gtk.HBox):
	def __init__(self, jamedia):
		gtk.HBox.__init__(self, False, 0)

		self.jamedia = jamedia
        	self.directoriodeiconos = ICONOS

	        self.ajuste = gtk.Adjustment(value=0, lower=0, upper=100, step_incr=1, page_incr=1)
        	self.barradeprogreso = gtk.HScrollbar(self.ajuste)
		self.barradeprogreso.set_update_policy(gtk.UPDATE_CONTINUOUS)

        	self.etiqueta_progreso = gtk.Label("%s %s" % ("%", 0))
        	caja_progreso = gtk.VBox()
        	caja_progreso.pack_start(self.barradeprogreso, True, True, 0)
        	caja_progreso.pack_start(self.etiqueta_progreso, False, False, 0)

		# ****** BOTON_ATRAS
	        self.imagenatras = gtk.Image()
        	self.imagenatras.set_from_file(self.directoriodeiconos + "atras.png")
        	self.botonatras = gtk.Button()
        	self.botonatras.add(self.imagenatras)
        	self.botonatras.connect("clicked",self.clickenatras)
		tooltips = gtk.Tooltips()
		tooltips.set_tip(self.botonatras, "Pista Anterior", tip_private=None)

		# ****** BOTON PLAY
	        self.imagenplay = gtk.Image()
	        self.imagenplay.set_from_file(self.directoriodeiconos + "play.png")
	        self.botonplay = gtk.Button()
	        self.botonplay.add(self.imagenplay)
		self.botonplay.connect("clicked",self.clickenplay_pausa)
		tooltips.set_tip(self.botonplay, "Pausa/Play", tip_private=None)

		# ****** BOTON SIGUIENTE
	        self.imagensiguiente = gtk.Image()
	        self.imagensiguiente.set_from_file(self.directoriodeiconos + "siguiente.png")
	        self.botonsiguiente = gtk.Button()
	        self.botonsiguiente.add(self.imagensiguiente)
        	self.botonsiguiente.connect("clicked",self.clickensiguiente)
		tooltips.set_tip(self.botonsiguiente, "Pista Siguiente", tip_private=None)

		# ****** BOTON STOP
	        self.imagenstop = gtk.Image()
	        self.imagenstop.set_from_file(self.directoriodeiconos + "stop.png")
	        self.botonstop = gtk.Button()
	        self.botonstop.add(self.imagenstop)
	        self.botonstop.connect("clicked",self.clickenstop)
		tooltips.set_tip(self.botonstop, "Detener Reproducción", tip_private=None)

		self.pack_start(caja_progreso, True, True, 0)
		self.pack_start(self.botonatras, False, False, 0)
		self.pack_start(self.botonplay, False, False, 0)
		self.pack_start(self.botonsiguiente, False, False, 0)
		self.pack_start(self.botonstop, False, False, 0)

        	self.show_all()

    	def clickenstop(self,widget):
	# detiene la reproducción
	        self.jamedia.mplayer_server.stop(None)

	def clickenplay_pausa(self, widget):
	# pausa el reproductor, solo si se esta reproduciendo un archivo
		self.jamedia.lista_de_reproduccion.play_pausa()

    	def clickenatras(self,widget):
	# tema anterior
		self.jamedia.lista_de_reproduccion.previuos()

    	def clickensiguiente(self,widget):
	# tema siguiente
		self.jamedia.lista_de_reproduccion.next()


if __name__ == "__main__":
    miventana = JAMedia()
    gtk.main()
