#!/usr/bin/env python
# -*- coding: utf-8 -*-

#   JAMedia_Downloader.py por:
#   Flavio Danesse <fdanesse@gmail.com>
#   Ceibal Jam - Uruguay
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gtk
import pygtk
pygtk.require("2.0")

import os, time, string, sys, gobject, signal

import subprocess
UPDATE_TIME = 10 # progress bar update time in ms
STDERR = "/dev/null"
youtubedl = "./youtube-dl.py"

class JAMedia_Downloader(gtk.Window):
	def __init__(self, jamedia):
		gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)

		self.jamedia = jamedia

		self.set_title("JAMedia Downloader 1")
		self.set_resizable(True)
		self.resize(640, 340)
        	self.connect("delete_event", self.delete_event)
        	self.set_border_width(3)

		# CONTENEDOR BASE
		self.base = gtk.VBox()

		# botones y cajas de textos
		self.base.pack_start(self.get_frame_accion(), False, False, 10)
		
		# frame descargas
		self.contenedor_descargas = None
		self.base.pack_start(self.get_frame_descargas(), True, True, 3)


		caja_abajo = gtk.HBox()
		bot = gtk.Button("salir")
		bot.connect("clicked", self.hiden)

		bot1 = gtk.Button("Actualizar Streaming de JAMedia")

		label = gtk.Label(" . . . ")
		caja_abajo.pack_start(bot1, False, False, 0)
		caja_abajo.pack_start(label, True, True, 0)
		caja_abajo.pack_end(bot, False, False, 0)

		bot1.connect("clicked", self.get_JAMedia_streamings, label)
		self.base.pack_start(caja_abajo, False, False, 3)

		self.add(self.base)
		#self.show_all() 

	def delete_event(self, widget, event, data=None):
		self.hide_on_delete()
		return True

	def hiden(self, widget):
		self.hide()
		if self.jamedia.mplayer_server.presentacion.estado == "playing":
			self.jamedia.mplayer_server.presentacion.next_play(None)

	def hacer_visible(self):
		self.show_all()

	def get_JAMedia_streamings(self, widget, label_stream):
	# Descarga la lista de streaming y actualiza las tablas.
		dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
		dialog.set_title("Mensaje JAMedia Downloader")
		dialog.set_markup("¿ Descargar y Actualizar Streaming de JAMedia ?")
		response = dialog.run()
		dialog.destroy()
		if response == gtk.RESPONSE_YES:
			label_stream.set_text("Actualizando Streaming de JAMedia.")
			self.jamedia.origenes_de_datos.Actualizar_Streaming_de_JAMedia(label_stream)
			self.jamedia.Lista_de_Radios = self.jamedia.origenes_de_datos.Cargar_Tabla("Radios")
			self.jamedia.Lista_de_Television = self.jamedia.origenes_de_datos.Cargar_Tabla("Television")

	def download(self, widget, entrada_texto, entrada_nombre):
		# Agregar si hay ip
		if len(list(self.contenedor_descargas)) < 5:
			direccion = entrada_texto.get_text()
			nombre = entrada_nombre.get_text()
			# limpiar los widgets
			entrada_texto.set_text("")
			entrada_nombre.set_text("")
			if direccion and nombre:
				directorio_de_descargas = self.jamedia.origenes_de_datos.directorio_videos
				self.contenedor_descargas.pack_start(JAMedia_Downloader2(self, direccion, nombre, directorio_de_descargas), False, False, 3)
		else:
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia Downloader")
			dialog.set_markup("No se Permiten más de 5 Descargas Simultáneas.")
			response = dialog.run()
			dialog.destroy()

	def eliminar_descarga(self, widget, descarga):
		self.contenedor_descargas.remove(descarga)

	def get_frame_descargas(self):
	# frame para apilar las descargas
		frame = gtk.Frame("Descargas Activas:")
		self.contenedor_descargas = gtk.VBox()
		frame.add(self.contenedor_descargas)
		scrolled_window = gtk.ScrolledWindow()
       		scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		scrolled_window.add_with_viewport(frame)
		return scrolled_window

	def get_frame_accion(self):
	# el frame de descarga con el boton y los cuadros de texto
		hbox = gtk.HBox()
		frame = gtk.Frame("Opciones de Descarga:")
		frame.add(hbox)

		entrada_texto = gtk.Entry()
		entrada_nombre = gtk.Entry()

		caja1 = gtk.VBox()
		label_descarga_info1 = gtk.Label("Dirección de descarga")
		caja1.pack_start(label_descarga_info1, True, True, 3)
		caja1.pack_start(entrada_texto, True, True, 3)

		caja2 = gtk.VBox()
		label_descarga_info2 = gtk.Label("Nombre de Archivo")
		caja2.pack_start(label_descarga_info2, True, True, 3)
		caja2.pack_start(entrada_nombre, True, True, 3)

		boton_descarga_video = gtk.Button("Descargar")

		hbox.pack_start(caja1, True, True, 3)
		hbox.pack_start(caja2, True, True, 3)

		hbox.pack_end(boton_descarga_video, False, False, 0)

		boton_descarga_video.connect("clicked", self.download, entrada_texto, entrada_nombre)
		return frame

	def mensaje_salir(self, widget):
	# Mensaje emergente para confirmar la salida del programa
		dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
		dialog.set_title("Mensaje ventana")
		dialog.set_markup("¿ Salir de ventana ?")
		response = dialog.run()
		dialog.destroy()
		if response == gtk.RESPONSE_YES:
			self.Salir(None)
		else:
			self.destroy(dialog)

class JAMedia_Downloader2(gtk.HBox):
# descarga utilizando youtube-dl
	def __init__(self, clase_base, direccion, nombre, directorio_de_descargas):
		gtk.HBox.__init__(self)

		self.clase_base = clase_base

		self.direccion_de_archivo = direccion
		self.nombre_de_archivo = nombre
		self.directorio_de_descargas = directorio_de_descargas

		self.ejecutable = youtubedl
		self.youtubedl = None
		self.salida = None
		self.Actualizador = None
		self.estado = None

		self.STDOUT = "/tmp/outvideos%d" % time.time()

		self.etiqueta = gtk.Label("Conectando . . .")
		self.boton = gtk.Button("Cerrar")
		self.boton_ver = gtk.Button("Ver con JAMedia")
		self.pack_start(self.boton, False, False, 3)
		self.pack_start(self.etiqueta, True, True, 3)
		self.pack_start(self.boton_ver, False, False, 3)
		self.show_all()

		self.boton.connect("clicked", self.informa)
		self.boton_ver.hide()

		self.boton_ver.connect("clicked", self.ver_video_en_descarga)
		self.ver_mientras_descarga = False
		self.download_archivo()

	def informa(self, widget):
		if self.etiqueta.get_text() == "Descarga Completada":
			self.fin(None)
			self.clase_base.eliminar_descarga(None, self)
			return
		dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
		dialog.set_title("Mensaje JAMedia Downloader")
		dialog.set_markup("Actualmente, las descargas no pueden detenerse. ¿ Igual Deseas Eliminar el Indicador de Descarga ?")
		response = dialog.run()
		dialog.destroy()
		if response == gtk.RESPONSE_YES:
			self.fin(None)
			self.clase_base.eliminar_descarga(None, self)
			return

	def download_archivo(self):
	# descarga un video desde internet
		self.nombre_de_archivo = str(self.nombre_de_archivo + ".ogg")
		archivo = self.directorio_de_descargas + self.nombre_de_archivo

		estructura = "%s %s %s %s" % (self.ejecutable, self.direccion_de_archivo, "-o", archivo)
		
		self.youtubedl = subprocess.Popen(estructura, shell=True, stdout=open(self.STDOUT,"w+b"), stderr=open(self.STDOUT,"r+b"), universal_newlines=True)
		self.salida = open(self.STDOUT,"r")

		if self.Actualizador: gobject.source_remove(self.Actualizador)
		self.Actualizador = gobject.timeout_add(UPDATE_TIME, self.Progreso)
		self.estado = "Descargando"

	def Progreso(self):
	# Reproduce archivos de Audio y Video
		continuar = True
		line = self.salida.readline()
		if line:
			try:
				self.etiqueta.set_text(str(line))
			except:
				pass

			lista = line.split()
			if len(lista) == 8:
			# el boton ver se muestra solo si se ha descargado al menos el 10% del archivo
				porcentaje = int(lista[1].split(".")[0])
				if porcentaje >= 10:
					self.boton_ver.show()
					if self.ver_mientras_descarga:
					# reproduce el video mientras se descarga
						self.ver_mientras_descarga = False
						self.clase_base.jamedia.ver_video_en_descarga(self.nombre_de_archivo)
						self.clase_base.hiden(None)
				else:
					self.boton_ver.hide()

			if not bool(line.split()):
			# Si la linea queda vacía
				continuar = False
				self.etiqueta.set_text("No se ha Podido Descargar el Video")
			if "100.0%" in line.split():
			# si ya se descargó todo
				continuar = False
				self.etiqueta.set_text("Descarga Completada")
				self.boton_ver.hide()
		return continuar

	def ver_video_en_descarga(self, widget):
	# habilita la reproducción del video mientras se descarga
		self.ver_mientras_descarga = True
			
	def fin(self, widget):
		# os.kill(self.youtubedl.pid, signal.SIGKILL)
		self.youtubedl.kill()
		# No he podido encontrar la forma de detener el proceso de descarga

		self.salida.close()
		if self.Actualizador: gobject.source_remove(self.Actualizador)
		if os.path.exists(self.STDOUT):
			os.unlink(self.STDOUT)
		self.estado = None
		self.clase_base.jamedia.origenes_de_datos.set_permisos() # por compatibilidad con sugar

	'''
	Para cerrar una ventana sin destruirla:

		1. connect the Window's "delete-event" signal to a function
		2. in the function, have the window "hide_on_delete()"
		3. return True ( if True is not returned, the Window's children will be destroyed and everything will go to crap )

		def delete_event(self, widget, event, data=None):
			self.hide_on_delete()
			return True'''

if __name__ == "__main__":
    miventana = JAMedia_Downloader()
    gtk.main()
