#!/usr/bin/env python
# -*- coding: utf-8 -*-

#   Lista_de_Reproduccion.py por:
#   Flavio Danesse <fdanesse@gmail.com>
#   Ceibal Jam - Uruguay - Plan Ceibal
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import pygtk
pygtk.require("2.0")
import gtk
import gobject
import os
import string

class Lista_de_Reproduccion(gtk.TreeView):
# http://library.gnome.org/devel/pygtk/stable/class-gtktreeview.html
	def __init__(self, jamedia):
		gtk.TreeView.__init__(self)
		self.set_property("rules-hint", True)

		self.tipo = None
		self.jamedia = jamedia
		self.visible = True
		self.path = None

		# construir ListStore que muestra la lista de archivos en el directorio referido
		self.modelo = gtk.ListStore (str, str, str) # http://library.gnome.org/devel/pygtk/stable/class-gtkliststore.html
		self.construir_columnas_de_listas()

		# Detectar eventos del mouse, en particular click derecho para crear menu emergente
		self.add_events(gtk.gdk.BUTTON2_MASK)
		self.connect("row-activated", self.callback_activated, None) 	# doble click
		self.connect("button-press-event", self.handler_click)		# cualquier click segun boton

		self.set_model(self.modelo)
		self.show_all()

	def handler_click(self, widget, event):
	# reacciona a los clicks sobre las filas de tresstore
		boton = event.button 		# obtenemos el botón que se presionó
		pos = (event.x, event.y) 	# obtenemos las coordenadas
		tiempo = event.time 		# obtenemos el tiempo

		# Obteniendo datos a partir de coordenadas de evento
		path, columna, xdefondo, ydefondo = widget.get_path_at_pos(event.x, event.y)

		if boton == 1:
		# boton izquierdo
			return
		elif boton == 3:
		# Boton derecho
			# Abrir menu – popup, pasando el path de la fila seleccionada
			self.crear_menu_emergente(boton, pos, tiempo, path)
			return
		elif boton == 2:
		# boton central
			return
   	def crear_menu_emergente(self, boton, pos, tiempo, path):
	# un menu para agregar o eliminar radios de la base de datos
		menu = gtk.Menu()

		iter = self.modelo.get_iter(path)
		text = self.modelo.get_value(iter, 0)
		direccion = self.modelo.get_value(iter, 1)
		tipo = self.modelo.get_value(iter, 2)

		if tipo == "Audio_Video":
		# SI ES UN ARCHIVO DE AUDIO O VIDEO
			# Items del menu
			# Quitar de la lista
			quitar = gtk.MenuItem("Quitar de la Lista")
			menu.append(quitar)
			quitar.connect_object("activate", self.set_accion_archivos, path, "Quitar")

			# verificamos los permisos del archivo o directorio
			Plectura, Pescritura, Pejecucion = self.jamedia.origenes_de_datos.verificar_permisos(direccion)

			directorio = os.path.dirname(direccion)+"/"
			# Si no lo cargué desde el directorio de JAMediaVideos
			if Plectura and directorio != self.jamedia.origenes_de_datos.directorio_videos:
				# Copiar
				copiar = gtk.MenuItem("Copiar a JAMedia")
				menu.append(copiar)
				copiar.connect_object("activate", self.set_accion_archivos, path, "Copiar")
			if Pescritura and directorio != self.jamedia.origenes_de_datos.directorio_videos:
				# Mover
				mover = gtk.MenuItem("Mover a JAMedia")
				menu.append(mover)
				mover.connect_object("activate", self.set_accion_archivos, path, "Mover")
			if Pescritura:
				# Borrar
				borrar = gtk.MenuItem("Borrar el Archivo")
				menu.append(borrar)
				borrar.connect_object("activate", self.set_accion_archivos, path, "Borrar")
		else:
		# SI ES UN STREAMING
			# Items del menu
			# Quitar de la lista
			quitar = gtk.MenuItem("Quitar de la Lista")
			menu.append(quitar)
			quitar.connect_object("activate", self.set_accion_stream, path, "Quitar")
			# Copiar
			if self.tipo == "jamediaradio" or self.tipo == "jamediatv":
				copiar = gtk.MenuItem("Copiar a mis Streaming")
				menu.append(copiar)
				copiar.connect_object("activate", self.set_accion_stream, path, "Copiar")
			# mover
				mover = gtk.MenuItem("Mover a mis Streaming")
				menu.append(mover)
				mover.connect_object("activate", self.set_accion_stream, path, "Mover")
			# Borrar
			borrar = gtk.MenuItem("Eliminar Streaming")
			menu.append(borrar)
			borrar.connect_object("activate", self.set_accion_stream, path, "Borrar")
			# Agregar
			if self.tipo == "MisRadios" or self.tipo == "MisTelevision":
				agregar = gtk.MenuItem("Nuevo Streaming")
				menu.append(agregar)
				agregar.connect_object("activate", self.set_accion_stream, path, "Agregar")
			
		menu.show_all()
		#popup(parent_menu_shell, parent_menu_item, func, button, activate_time, data=None)
		gtk.Menu.popup(menu, None, None, None, boton, tiempo)

	def set_accion_stream(self, path, accion):
	# Recibe el path de la fila seleccionada en el modelo y una accion a realizar.
		iter = self.modelo.get_iter(path)
		text = self.modelo.get_value(iter, 0)
		direccion = self.modelo.get_value(iter, 1)
		tipo = self.modelo.get_value(iter, 2)

		if accion == "Quitar":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que deseas Quitar de la Lista ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				self.modelo.remove(iter)
		elif accion == "Borrar":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que deseas Borrar Definitivamente el Streaming ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
			# borrar streaming del archivo segun self.tipo
				stream = text + "," + direccion
				self.jamedia.origenes_de_datos.eliminar_streaming(stream, self.tipo)
				self.modelo.remove(iter)
				if self.tipo == "jamediaradio": self.jamedia.Lista_de_Radios = self.jamedia.origenes_de_datos.Cargar_Tabla("Radios")
				if self.tipo == "jamediatv": self.jamedia.Lista_de_Television = self.jamedia.origenes_de_datos.Cargar_Tabla("Television")
				if self.tipo == "MisRadios": self.jamedia.Lista_de_MisRadios = self.jamedia.origenes_de_datos.Cargar_Tabla("MisRadios")
				if self.tipo == "MisTelevision": self.jamedia.Lista_de_MisTelevision = self.jamedia.origenes_de_datos.Cargar_Tabla("MisTelevision")
		elif accion == "Copiar":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que deseas Copiar este streaming a tu Lista ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				if self.tipo == "jamediaradio":
					stream = text + "," + direccion
					self.jamedia.origenes_de_datos.agregar_streaming(stream, self.jamedia.origenes_de_datos.misradios)
					self.jamedia.Lista_de_MisRadios = self.jamedia.origenes_de_datos.Cargar_Tabla("MisRadios")
				elif self.tipo == "jamediatv":
					stream = text + "," + direccion
					self.jamedia.origenes_de_datos.agregar_streaming(stream, self.jamedia.origenes_de_datos.mistv)
					self.jamedia.Lista_de_MisTelevision = self.jamedia.origenes_de_datos.Cargar_Tabla("MisTelevision")
		elif accion == "Mover":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que deseas Mover este streaming a tu Lista ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				self.set_accion_stream(path, "Copiar")
				self.set_accion_stream(path, "Borrar")
		elif accion == "Agregar":
			boton_OK = gtk.Button("Si")
			boton_Cancel = gtk.Button("No")

			dialog = gtk.Dialog(title="Mensaje JAMedia", parent=self.jamedia, flags=gtk.DIALOG_MODAL | gtk.DIALOG_NO_SEPARATOR , buttons=None)
			dialog.set_size_request(350, 100)
			dialog.set_resizable(True)

			# Nombre
			caja1 = gtk.HBox()
			label1 = gtk.Label("Nombre: ")
			texto1 = gtk.Entry()
			caja1.pack_start(label1, False, False, 0)
			caja1.pack_start(texto1, True, True, 0)

			# Direccion
			caja2 = gtk.HBox()
			label2 = gtk.Label("Direccion: ")
			texto2 = gtk.Entry()
			caja2.pack_start(label2, False, False, 0)
			caja2.pack_start(texto2, True, True, 0)

			# Botones
			caja3 = gtk.HBox()
			boton_guardar = gtk.Button("Guardar")
			boton_cancelar = gtk.Button("Cancelar")
			caja3.pack_start(boton_guardar, True, False, 0)
			caja3.pack_start(boton_cancelar, True, False, 0)

			dialog.vbox.pack_start(caja1, False, False, 0)
			dialog.vbox.pack_start(caja2, False, False, 0)
			dialog.vbox.pack_start(caja3, False, False, 10)

			boton_cancelar.connect("clicked", self.jamedia.destroy, dialog)
			boton_guardar.connect("clicked", self.new_streaming, texto1, texto2)
			boton_guardar.connect("clicked", self.jamedia.destroy, dialog)

			dialog.show_all()

	def new_streaming(self, widget, texto1, texto2):
	# confirma agregado de streming
		nombre = texto1.get_text()
		direccion = texto2.get_text()

		if not nombre or not direccion:
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("Debes especificar un Nombre y una Dirección de Reproducción.")
			response = dialog.run()
			dialog.destroy()
			return

		stream = nombre + "," + direccion

		dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
		dialog.set_title("Mensaje JAMedia")
		dialog.set_markup("¿ Confirmas que deseas Agregar este streaming a tu Lista ?")
		response = dialog.run()
		dialog.destroy()
		if response == gtk.RESPONSE_YES:
			if self.tipo == "MisRadios":
				self.jamedia.origenes_de_datos.agregar_streaming(stream, self.jamedia.origenes_de_datos.misradios)
				self.jamedia.Lista_de_MisRadios = self.jamedia.origenes_de_datos.Cargar_Tabla("MisRadios")
				tipo = "Radio"
				lista = []
				for x in self.jamedia.Lista_de_MisRadios:
					elem = x.split(",")
					texto = elem[0]		# lo que se ve en la lista
					direccion = elem[1]	# la url
					elemento = [texto, direccion, tipo]
					lista.append(elemento)
				self.set_listore(lista, "MisRadios")

			elif self.tipo == "MisTelevision":
				self.jamedia.origenes_de_datos.agregar_streaming(stream, self.jamedia.origenes_de_datos.mistv)
				self.jamedia.Lista_de_MisTelevision = self.jamedia.origenes_de_datos.Cargar_Tabla("MisTelevision")
				tipo = "TV"
				lista = []
				for x in self.jamedia.Lista_de_MisTelevision:
					elem = x.split(",")
					texto = elem[0]		# lo que se ve en la lista
					direccion = elem[1]	# la url
					elemento = [texto, direccion, tipo]
					lista.append(elemento)
				self.set_listore(lista, "MisTelevision")

	def set_accion_archivos(self, path, accion):
	# Recibe el path de la fila seleccionada en el modelo y una accion a realizar.
		iter = self.modelo.get_iter(path)
		text = self.modelo.get_value(iter, 0)
		direccion = self.modelo.get_value(iter, 1)
		tipo = self.modelo.get_value(iter, 2)

		# es necesario determinar si es audio o video lo que se copia
		if accion == "Copiar":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que Deseas Copiar el Archivo ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				self.jamedia.origenes_de_datos.copiar_archivo_JAMedia_Video(direccion)
		elif accion == "Borrar":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que Deseas Borrar el Archivo ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				self.jamedia.origenes_de_datos.borrar_archivo_JAMedia(direccion)
				self.modelo.remove(iter)
		elif accion == "Mover":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que Deseas Mover el Archivo ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				self.jamedia.origenes_de_datos.mover_archivo_JAMedia(direccion)
				self.modelo.remove(iter)
		elif accion == "Quitar":
			dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_YES_NO)
			dialog.set_title("Mensaje JAMedia")
			dialog.set_markup("¿ Confirmas que deseas Quitar de la Lista ?")
			response = dialog.run()
			dialog.destroy()
			if response == gtk.RESPONSE_YES:
				self.modelo.remove(iter)

	def callback_activated (self, treeview, path, view_column, user_param1):
	# Cuando se hace doble click sobre una fila, se selecciona y reproduce
		# Obtengo el valor almacenado
		iter = treeview.modelo.get_iter(path)
		url = treeview.modelo.get_value(iter, 1)
		tipo = treeview.modelo.get_value(iter, 2)
		self.jamedia.mplayer_server.quit(None) 			# Detener el reproductor
		self.jamedia.mplayer_server.play(None, url, tipo) 	# Escuchar la radio

	def play_pausa(self):
		# verificar si hay un path, si no hay, se reproducirá el 0
		path = self.get_path_para_play_pausa()

		if path == None:
		# si no hay nada seleccionado, se reproduce la primera
			treeselection = self.get_selection()
			treeselection.set_mode(gtk.SELECTION_SINGLE)
			treeselection.select_path(0)
			self.select_and_play(0)
			return
		else:
		# si hay algo seleccionado, se verifica el tipo de datos primero
			(pista, tipo) = self.get_datos_de_seleccion(path)
			if tipo != "Audio_Video":
			# si es radio o tv, se reproduce la seleccion
				if pista != self.jamedia.mplayer_server.pista_actual:
					treeselection = self.get_selection()
					treeselection.set_mode(gtk.SELECTION_SINGLE)
					treeselection.select_path(path)
					self.select_and_play(path)
					return
				else:
					if self.jamedia.mplayer_server.estado == "stoped Audio_Video":
					# en caso de tener radio o tv en stop
						self.select_and_play(path)
			else:
			# si se está reproduciendo un archivo de audio o video
				if pista == self.jamedia.mplayer_server.pista_actual:
				# si la pista seleccionada es la que se está reproduciendo
					self.jamedia.mplayer_server.pause_play()
					return
				else:
				# si no es la misma pista
					self.select_and_play(path)
					return

	def get_datos_de_seleccion(self, path):
	# obtiene los datos de reproduccion de la pista seleccionada
		iter = self.modelo.get_iter(path)
		url = self.modelo.get_value(iter, 1)
		tipo = self.modelo.get_value(iter, 2)
		if tipo == "Audio_Video":
			palabras = string.split(url)
			nu = ""
			for palabra in palabras:
				if nu == "":
					nu = str(nu) + palabra
				else:
					nu = str(nu) + str("\ ") + palabra
			pista = nu
		else:
			pista = url

		return (pista, tipo)

	def get_path_para_play_pausa(self):
	# devuelve el path seleccionado o None
		(modelo, iter) = self.get_selection().get_selected()
		path = None
		if iter:
			treemodelrow = modelo[iter]
			path = treemodelrow.path
		return path

	def next(self):
	# pasa a la pista siguiente
		(modelo, iter) = self.get_selection().get_selected()		# modelo e iterador
		path = 0
		if iter:
			treemodelrow = modelo[iter]				# iterador por fila
			#print treemodelrow.path				# el path actualmente seleccionado
			try:
			# Si hay un elemento más
				path = treemodelrow.next.path
			except:
			# Si no hay, ir al primero
				pass	
		treeselection = self.get_selection()
		treeselection.set_mode(gtk.SELECTION_SINGLE)
		treeselection.select_path(path)
		self.select_and_play(path)

	def previuos(self):
	# pasa a la pista anterior
		(modelo, iter) = self.get_selection().get_selected()
		path = 0
		if iter:
			treemodelrow = modelo[iter]
			path = treemodelrow.path
			
			a = path[0]-1
			if a >= 0:
				path = (a,)
			else:
				path = 0
		treeselection = self.get_selection()
		treeselection.set_mode(gtk.SELECTION_SINGLE)
		treeselection.select_path(path)
		self.select_and_play(path)

	def select_and_play(self, path):
	# Reproduce 
		try:
			iter = self.modelo.get_iter(path)
			url = self.modelo.get_value(iter, 1)
			tipo = self.modelo.get_value(iter, 2)
			self.jamedia.mplayer_server.quit(None) # Detener el reproductor
			self.jamedia.mplayer_server.play(None, url, tipo) # Escuchar la radio
		except:
			return

# --------- CONSTRUCCIÓN DE LISTORE --------- #
	def construir_columnas_de_listas(self):
	# Columnas para ListStore
		# Nombre de la columna, tipo de cellrender, Numero de columna comenzando en 0
		columna = gtk.TreeViewColumn('Lista de Reproducción')
        	# crear CellRenderers
        	celda_de_texto = gtk.CellRendererText() 		# para el texto
		celda_de_direccion = gtk.CellRendererText() 		# para la direccion de Reproducción
		celda_de_direccion.set_property('visible', False) 	# la direccion de Reproducción no debe ser visible
		celda_de_tipo = gtk.CellRendererText() 			# puede ser audio-video, radio o TV
		celda_de_tipo.set_property('visible', False) 		# tampoco debe ser visible

	        # agregar las celdas a la columna
        	columna.pack_start(celda_de_texto, True)
		columna.pack_start(celda_de_direccion, True)
		columna.pack_start(celda_de_tipo, True)

		self.append_column (columna) # treeview.append_column (columna)

        	columna.set_attributes(celda_de_texto, text=0)
		columna.set_attributes(celda_de_direccion, text=1)
		columna.set_attributes(celda_de_tipo, text=2)

        	columna.set_attributes(celda_de_texto, text=0)
# --------- CONSTRUCCIÓN DE LISTORE --------- #
	
	def set_listore(self, lista, tipo):
	# lista = [ [texto para mostrar, dirección de reproducción, texto tipo reproducción], . . . hasta n elementos]
		self.tipo = tipo
		self.modelo.clear()
		for elemento in lista:
			self.modelo.append(elemento)

