#!/usr/bin/env python
# -*- coding: utf-8 -*-

#   Mplayer_Reproductor.py por:
#   Flavio Danesse <fdanesse@gmail.com>
#   Ceibal Jam - Uruguay
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gobject
import time
import string
import os

from Presentacion import Presentacion

import subprocess
UPDATE_TIME = 10 # progress bar update time in ms
STDOUT = "/tmp/out%d" % time.time()
STDERR = "/dev/null"
MPLAYER = "exec ./mplayer"

class Mplayer_Reproductor():
	def __init__(self, jamedia):
		self.jamedia = jamedia

		self.ejecutable = MPLAYER
		self.pantalla = self.jamedia.pantalla.area_de_reproduccion
		self.barra_de_progreso = self.jamedia.barra_de_estado.Barra_de_Reproduccion

		self.tipo_de_datos = None
		self.mplayer = None
		self.salida = None
		self.entrada = None
		self.Actualizador = None
		self.estado = None
		self.pista_actual = None

		self.presentacion = Presentacion(self.pantalla, self.ejecutable)
		self.control = False

	def abrir_presentacion(self):
		# Presentacion
		mov = os.getcwd() + "/Iconos/" + "JAMedia-presentacion.mov"
		self.presentacion.play(None, mov)

	def play(self, widget, direccion, tipo_de_datos):
	# Reproduce segun la fuente de datos

		self.tipo_de_datos = tipo_de_datos

		if tipo_de_datos == "Radio":
			if self.presentacion.estado == None: self.abrir_presentacion()
			self.play_radio(direccion)
		elif tipo_de_datos == "TV":
			if self.presentacion.estado == "playing": self.presentacion.quit(None)
			self.play_tv(direccion)
		
		elif tipo_de_datos == "Audio_Video":
			if self.presentacion.estado == "playing": self.presentacion.quit(None)
			self.play_Audio_Video(direccion)

	def play_Audio_Video(self, direccion):
	# Reproduce una Lista de Archivos de Audio o Video
		# La direccion debe tener este formato, de lo contrario no funciona
		# direccion = "/media/2865-AB46/Archivos\ de\ prueba\ para\ JAMedia/Shakira02.mpeg"
		# por eso:
		palabras = string.split(direccion)
		nu = ""
		for palabra in palabras:
			if nu == "":
				nu = str(nu) + palabra
			else:
				nu = str(nu) + str("\ ") + palabra
		self.pista_actual = nu
		self.play_archivo(self.pista_actual)

	def play_archivo(self, direccion):
		estructura = "%s -cache %i -wid %i -slave -idle" % (self.ejecutable, 1024, self.pantalla.window.xid)
		self.mplayer = subprocess.Popen(estructura, shell=True, stdin=subprocess.PIPE, 
			stdout=open(STDOUT,"w+b"), stderr=open(STDOUT,"r+b"), universal_newlines=True)

		self.entrada = self.mplayer.stdin
		self.salida = open(STDOUT,"r")

		self.entrada.write("loadfile %s 0\n" % direccion)
		self.entrada.flush()

		if self.Actualizador: gobject.source_remove(self.Actualizador)
		self.Actualizador = gobject.timeout_add(UPDATE_TIME, self.Actualizar_Barra_de_Progreso)
		self.estado = "playing Audio_Video"
		self.barra_de_progreso.imagenplay.set_from_file(self.barra_de_progreso.directoriodeiconos + "pausa.png")

	def Actualizar_Barra_de_Progreso(self):
	# Reproduce archivos de Audio y Video
		continuar = True
		if not self.entrada.closed:
			line = self.execute("get_percent_pos") # obtenemos la posicion en el archivo

			if line and line.startswith("Video: no video") and self.presentacion.estado == None:
				self.abrir_presentacion()

			if line and line.startswith("ANS_PERCENT_POSITION"):
				# tomamos los datos de porcentaje
				try:
					progress = int(line[line.index('=')+1:-1])
                			self.barra_de_progreso.ajuste.value = progress
					self.barra_de_progreso.etiqueta_progreso.set_text(str("%s %s") % ("%", progress))
					if progress == 0: self.control = False
					if progress >= 99:
						self.barra_de_progreso.imagenplay.set_from_file(self.barra_de_progreso.directoriodeiconos + "play.png")
						self.next_play(None)
						self.control = True
	    			except Exception, e:
					print "Error en Actualizar Barra de Progreso: %s" % (e)
		else: 
			continuar = False
		return continuar

	def execute(self, command, parseValue=False):
	# Ejecuta comandos mplayer -slave
		self.entrada.write("%s\n" % command)
		self.entrada.flush()
		line = self.salida.readline()
		answer = ""
		if line:
			if parseValue :
				answer = line[line.index('=')+1:-1]
			else: answer = line
		return answer 

	def next_play(self, widget):
	# cambia a la pista siguiente
		self.jamedia.lista_de_reproduccion.next()
		
	def pause_play(self):
	# Detiene la reproduccion
		try:
			if self.entrada:
				if self.estado == "playing Audio_Video": # pausa
					self.entrada.write('%s\n' % "pause")
					self.entrada.flush()
					if self.Actualizador: gobject.source_remove(self.Actualizador)
					self.barra_de_progreso.imagenplay.set_from_file(self.barra_de_progreso.directoriodeiconos + "play.png")
					self.estado = "paused Audio_Video"
				elif self.estado == "paused Audio_Video": 
					self.entrada.write('%s\n' % "pause") # hace unpause
					self.entrada.flush()
					if self.Actualizador: gobject.source_remove(self.Actualizador)
					self.Actualizador = gobject.timeout_add(UPDATE_TIME, self.Actualizar_Barra_de_Progreso)
					self.barra_de_progreso.imagenplay.set_from_file(self.barra_de_progreso.directoriodeiconos + "pausa.png")
					self.estado = "playing Audio_Video"
				elif self.estado == "stoped Audio_Video": # replay
					self.entrada.write("loadfile %s 0\n" % self.pista_actual)
					self.entrada.flush()
					if self.Actualizador: gobject.source_remove(self.Actualizador)
					self.Actualizador = gobject.timeout_add(UPDATE_TIME, self.Actualizar_Barra_de_Progreso)
					self.barra_de_progreso.imagenplay.set_from_file(self.barra_de_progreso.directoriodeiconos + "pausa.png")
					self.estado = "playing Audio_Video"

		except Exception, e:
			print "HA OCURRIDO UN ERROR EN PAUSE_PLAY DEL REPRODUCTOR", e

	def stop(self, widget):
	# Detiene la reproduccion
		try:
			if self.entrada:
				self.entrada.write('%s\n' % "stop")
				self.entrada.flush()
				if self.Actualizador: gobject.source_remove(self.Actualizador)
				self.barra_de_progreso.imagenplay.set_from_file(self.barra_de_progreso.directoriodeiconos + "play.png")
                		self.barra_de_progreso.ajuste.value = 0
				self.barra_de_progreso.etiqueta_progreso.set_text(str("%s %s") % ("%", 0))
				self.estado = "stoped Audio_Video"
		except Exception, e:
			print "HA OCURRIDO UN ERROR EN STOP DEL REPRODUCTOR", e

	def quit(self, widget):
	# Detiene la reproduccion
		try:
			if self.entrada:
				self.entrada.write('%s\n' % "quit")
				self.entrada.flush()
				if self.Actualizador: gobject.source_remove(self.Actualizador)
				self.barra_de_progreso.imagenplay.set_from_file(self.barra_de_progreso.directoriodeiconos + "play.png")
                		self.barra_de_progreso.ajuste.value = 0
				self.barra_de_progreso.etiqueta_progreso.set_text(str("%s %s") % ("%", 0))
		except Exception, e:
			print "HA OCURRIDO UN ERROR EN QUIT DEL REPRODUCTOR", e

		if os.path.exists(STDOUT):
			os.unlink(STDOUT)
		self.estado = None
		self.pista_actual = None

	def play_radio(self, direccion):
	# Reproduce Radios y Televisión on-line
		estructura = "%s -cache %i -slave -idle" % (self.ejecutable, 32)
		self.mplayer = subprocess.Popen(estructura, shell=True, stdin=subprocess.PIPE, 
			stdout=open(STDOUT,"w+b"), stderr=open(STDOUT,"r+b"), universal_newlines=True)

		self.entrada = self.mplayer.stdin
		self.salida = open(STDOUT,"r")

		self.entrada.write("loadfile %s 0\n" % direccion)
		self.entrada.flush()

		if self.Actualizador: gobject.source_remove(self.Actualizador)
		self.estado = "playing Radio"

		self.pista_actual = direccion

	def play_tv(self, direccion):
	# Reproduce Televisión on-line
		estructura = "%s -cache %i -wid %i -slave -idle" % (self.ejecutable, 1024, self.pantalla.window.xid)
		self.mplayer = subprocess.Popen(estructura, shell=True, stdin=subprocess.PIPE, 
			stdout=open(STDOUT,"w+b"), stderr=open(STDOUT,"r+b"), universal_newlines=True)

		self.entrada = self.mplayer.stdin
		self.salida = open(STDOUT,"r")

		self.entrada.write("loadfile %s 0\n" % direccion)
		self.entrada.flush()

		if self.Actualizador: gobject.source_remove(self.Actualizador)
		self.estado = "playing TV"

		self.pista_actual = direccion
