#!/usr/bin/env python
# -*- coding: utf-8 -*-

#   Presentacion.py por:
#   Flavio Danesse <fdanesse@gmail.com>
#   Ceibal Jam - Uruguay
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gobject
import time
import string
import os

import subprocess
UPDATE_TIME = 10 # progress bar update time in ms
STDOUT = "/tmp/outx%d" % time.time()
STDERR = "/dev/null"

class Presentacion():

	def __init__(self, pantalla, MPLAYER):

		self.ejecutable = MPLAYER
		self.pantalla = pantalla
		self.mplayer = None
		self.salida = None
		self.entrada = None
		self.Actualizador = None

		self.estado = None
		self.direccion = None
		self.control = False

	def play(self, widget, direccion):
	# Reproduce una Lista de Archivos de Audio o Video
		self.direccion = direccion
	
		estructura = "%s -cache %i -wid %i -slave -idle" % (self.ejecutable, 1024, self.pantalla.window.xid)
		self.mplayer = subprocess.Popen(estructura, shell=True, stdin=subprocess.PIPE, 
			stdout=open(STDOUT,"w+b"), universal_newlines=True, stderr=open(STDOUT,"r+b"))

		self.entrada = self.mplayer.stdin
		self.salida = open(STDOUT,"r")

		self.entrada.write("loadfile %s 0\n" % direccion)
		self.entrada.flush()

		if self.Actualizador: gobject.source_remove(self.Actualizador)
		self.Actualizador = gobject.timeout_add(UPDATE_TIME, self.Actualizar)
		self.estado = "playing"

	def Actualizar(self):
	# Reproduce archivos de Audio y Video
		continuar = True
		if not self.entrada.closed:
			line = self.execute("get_percent_pos") # obtenemos la posicion en el archivo
			if line and line.startswith("ANS_PERCENT_POSITION"):
				# tomamos los datos de porcentaje
				progress = int(line[line.index('=')+1:-1])
				try:
					if progress == 0: self.control = False
					if progress >= 99 and not self.control:
						self.next_play(None)
						self.control = True
				except:
					pass
		else: 
			continuar = False
		return continuar

	def execute(self, command, parseValue=False):
	# Ejecuta comandos mplayer -slave
		self.entrada.write("%s\n" % command)
		self.entrada.flush()
		line = self.salida.readline()
		answer = ""
		if line:
			if parseValue :
				answer = line[line.index('=')+1:-1]
			else: answer = line
		return answer 

	def next_play(self, widget):
	# cambia a la pista siguiente
		try:
			self.entrada.write("loadfile %s 0\n" % self.direccion)
			self.entrada.flush()
		except:
			print "ERROR en next_play presentacion"

	def quit(self, widget):
	# Detiene la reproduccion
		try:
			if self.entrada:
				self.entrada.write('%s\n' % "quit")
				self.entrada.flush()
				if self.Actualizador: gobject.source_remove(self.Actualizador)
		except:
			print "HA OCURRIDO UN ERROR EN QUIT DE LA PRESENTACION"
		if os.path.exists(STDOUT):
			os.unlink(STDOUT)
		self.estado = None
		time.sleep(1)
